Function Piezo

x=List_xy[2*p];
y=List_xy[2*p+1];
LSurface[]={0,0,0,0,0,0,0,0,0,0,0,0,0};
lc=0;
Rext=2*Lp/3;
Rin=Lp/3;
i=0;
List[]={Rin,-Rin,Rext,-Rext,Lp,-Lp};

sump=newp; //Compteur de Point
suml=newl; //Compteur de Line & Circle
sumll=newll; //Compteur Line Loop
sums=news; //Compteur de Surface
sumv=newv; //Compteur de Volume

/////////////////////////////////////
// Création des points
/////////////////////////////////////
Point (sump)={x,y,0,lc}; sump=sump+1;
For i In {0:5:1}						//25 points créés
Point(sump)={x+List[i],y+List[i],0,lc};
Point(sump+1)={x,y+List[i],0,lc};
Point(sump+2)={x-List[i],y+List[i],0,lc};
Point(sump+3)={x-List[i],y,0,lc};
sump=sump+4;
EndFor
Point(sump)={(x+(Sqrt(2)*Rext/2)),(y+(Sqrt(2)*Rext/2)),0.,lc}; sump+=1;
Point(sump)={(x-(Sqrt(2)*Rext/2)),(y+(Sqrt(2)*Rext/2)),0.,lc}; sump=sump+1;
Point(sump)={(x-(Sqrt(2)*Rext/2)),(y-(Sqrt(2)*Rext/2)),0.,lc}; sump=sump+1;
Point(sump)={(x+(Sqrt(2)*Rext/2)),(y-(Sqrt(2)*Rext/2)),0.,lc}; sump=sump+1;
/////////////////////////////////////
// 29 points créés
/////////////////////////////////////
//Printf("Sump = %g ",sump); //=+30
/////////////////////////////////////

/////////////////////////////////////
// Créations des lignes
/////////////////////////////////////
For i In {(sump-28):(sump-5):4}
Line(suml)={i,i+1}; suml=suml+1;
Line(suml)={i+1,i+2}; suml=suml+1;
Line(suml)={i+2,i+3}; suml=suml+1;
If ((i+3)==(sump-21) || (i+3)==(sump-13) ||(i+3)==(sump-5))
Line(suml)={i+3,i-4}; suml=suml+1;
EndIf
If ((i+3)!=(sump-21)  && (i+3)!=(sump-13) && (i+3)!=(sump-5))
Line(suml)={i+3,i+4}; suml=suml+1;
EndIf
EndFor

For i In {suml-24:suml-1}
Transfinite Line {i}=5;
EndFor
/////////////////////////////////////
//24 lignes créées 
/////////////////////////////////////
//Printf("Suml = %g ",suml); //=25
/////////////////////////////////////

/////////////////////////////////////
//Mémorisation des contours piezo
/////////////////////////////////////
Printf("Sll = %g ",sumll);
Line Loop (sumll)={suml-1,suml-2,suml-3,suml-4,suml-5,suml-6,suml-7,suml-8};
List_LL[p]=sumll; sumll=sumll+1;



For i In {sump-27:sump-13:2}
Line(suml)={i,i+8};
If (i<=sump-21)
Transfinite Line{suml}=5;
EndIf
If (i>sump-21)
Transfinite Line{suml}=3;
EndIf
suml=suml+1;
EndFor
/////////////////////////////////////
//32 lignes créées 
/////////////////////////////////////
//Printf("Suml = %g ",suml); //=33
/////////////////////////////////////

Line(suml)={sump-12,sump-4};suml=suml+1;
Line(suml)={sump-10,sump-3};suml=suml+1;
Line(suml)={sump-8,sump-2};suml=suml+1;
Line(suml)={sump-6,sump-1};suml=suml+1;
Transfinite Line {suml-4,suml-3,suml-2,suml-1}=3;
/////////////////////////////////////
//36 lignes créées 
/////////////////////////////////////
//Printf("Suml = %g ",suml); //=37
/////////////////////////////////////

/////////////////////////////////////
//Création cercles
/////////////////////////////////////
//Intérieur
For i In {sump-27:sump-21:2}
If (i<sump-21)
Circle(suml)={i,sump-29,i+2};
EndIf
If (i==sump-21)
Circle(suml)={i,sump-29,i-6};
EndIf
Transfinite Line(suml)=9;
suml=suml+1;
EndFor

//Extérieur
Circle(suml)={sump-19,sump-29,sump-3};
Cext0[]=Rotate{{0,0,1},{x,y,0},Pi/4}{Duplicata{Line{suml};}}; //Printf("Cext0[0] = %g ",Cext0[0]);
Cext1[]=Rotate{{0,0,1},{x,y,0},Pi/2}{Duplicata{Line{suml,Cext0[0]};}}; //Printf("Cext1[0] = %g , Cext1[1] = %g",Cext1[0],Cext1[1]);
Cext2[]=Rotate{{0,0,1},{x,y,0},Pi}{Duplicata{Line{suml,Cext0[0],Cext1[0],Cext1[1]};}}; //Printf("Cext2[0] = %g , Cext2[1] = %g, Cext2[2] = %g , Cext2[3] = %g",Cext2[0],Cext2[1],Cext2[2],Cext2[3]);
suml=suml+8;
For i In {1:8}
Transfinite Line{suml-i}=5;
EndFor 
/////////////////////////////////////
//48 lignes créées 
/////////////////////////////////////
//Printf("Suml = %g ",suml); //=+49
/////////////////////////////////////

/////////////////////////////////////
// Créations des surfaces
/////////////////////////////////////
//Centre Piezo
Line Loop(sumll)={suml-12,suml-11,suml-10,suml-9}; 
Plane Surface(sums)={sumll}; LSurface[0]=sums;
Transfinite Surface{sums}={sump-27,sump-25,sump-23,sump-21};
Recombine Surface(sums); sums=sums+1; sumll=sumll+1; //sums=+2 ; sumll=+2;


//Anneau Intérieur
Line Loop(sumll)={suml-12,suml-23,-(suml-7),-(suml-8),-(suml-24)};
Plane Surface (sums)={sumll}; LSurface[1]=sums; sumll=sumll+1; //sumll=+3;
Transfinite Surface{sums}={sump-17,sump-19,sump-27,sump-25}; Recombine Surface(sums);
Sin0[]=Rotate{{0,0,1},{x,y,0},Pi/2}{Duplicata{Surface{sums};}}; LSurface[2]=Sin0[0];
Transfinite Surface{Sin0[0]}={sump-15,sump-17,sump-25,sump-23}; 
Sin1[]=Rotate{{0,0,1},{x,y,0},Pi}{Duplicata{Surface{sums,Sin0[0]};}}; LSurface[3]=Sin1[0];LSurface[4]=Sin1[1];
Transfinite Surface{Sin1[0]}={sump-13,sump-15,sump-23,sump-21}; 
Transfinite Surface{Sin1[1]}={sump-19,sump-13,sump-21,sump-27}; 

sums=Sin1[1]+1; //sums=+56+1=+57

// Anneau Extérieur
Line Loop (sumll)={suml-8,-(suml-15),-(suml-31),-(suml-20)}; Plane Surface(sums)={sumll}; LSurface[5]=sums;
sumll=sumll+1; //sumll=4;
Transfinite Surface{sums}={sump-3,sump-19,sump-11,sump-10};Recombine Surface(sums); sums=sums+1; //sums=+58
Line Loop (sumll)={suml-7,suml-19,-(suml-30),suml-15}; Plane Surface(sums)={sumll}; LSurface[6]=sums;
sumll=sumll+1; //sumll=5;
Transfinite Surface{sums}={sump-3,sump-17,sump-9,sump-10};Recombine Surface(sums); 
sums=sums+1; // sums=+59
Sext0[]=Rotate{{0,0,1},{x,y,0},Pi/2}{Duplicata{Surface{sums-1,sums-2};}}; 
LSurface[7]=Sext0[0]; LSurface[8]=Sext0[1];
Sext1[]=Rotate{{0,0,1},{x,y,0},Pi}{Duplicata{Surface{sums-1,sums-2,Sext0[0],Sext0[1]};}};
LSurface[9]=Sext1[0]; LSurface[10]=Sext1[1]; LSurface[11]=Sext1[2]; LSurface[12]=Sext1[3];
sums=Sext1[3]+1;
/////////////////////////////////////
//13 surfaces crées
/////////////////////////////////////
//Printf("Sums = %g ",sums); //=+81
/////////////////////////////////////

/////////////////////////////////////
// Créations des volumes
/////////////////////////////////////
//Piezo[]=Extrude{0,0,1E-3}{Surface{LSurface[0],LSurface[1],LSurface[2],LSurface[3],LSurface[4]};Layers{1};Recombine;};


/////////////////////////////////////
//Physical Definition
/////////////////////////////////////
//Physical Volume(P)={Piezo[]};
//{Piezo[sumv],Piezo[sumv+6],Piezo[sumv+13],Piezo[sumv+20], Piezo[sumv+27]}
//Physical Surface (PS)={LSurface[]};
//LSurface[0],LSurface[1],LSurface[2],LSurface[3],LSurface[4],LSurface[5],LSurface[6],LSurface[7],LSurface[8],LSurface[9],LSurface[10],LSurface[11],LSurface[12]





Return
